package examples.chat;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

public class Speaker extends ActorReference  {
	public Speaker selfReference;

	public Speaker(UAN uan) { super(uan); }
	public Speaker(UAL ual) { super(ual); }

	public static void main(String args[]) {
		Speaker instance = new Speaker();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public Speaker() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected Speaker self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		public void talk(String uan, String myMessage) {
			Chat c = new Chat(new UAN(uan));
			{
				// standardOutput<-println(myMessage)
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { myMessage };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			{
				// c<-reply("message received")
				{
					Message message = new Message( self, c, "reply", null );
					Object _arguments[] = { "message received" };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public void whereAmI(String myUAN) {
			{
				// standardOutput<-println("Speaker started with uan: " + myUAN)
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { "Speaker started with uan: " + myUAN };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public void act(String args[]) {
			if (args.length > 2) {
				{
					// standardOutput<-println("Usage: java examples.chat.Sender <UAN> ")
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { "Usage: java examples.chat.Sender <UAN> " };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
				return;
			}
			if (args.length == 1) 			{
				Token token_2_0 = new Token();
				// bind(args[0])
				{
					Message message = new Message( self, self, "bind", token_2_0.createInput() );
					Object _arguments[] = { args[0] };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// whereAmI(args[0])
				{
					Message message = new Message( self, self, "whereAmI", null );
					Object _arguments[] = { args[0] };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_0.createOutput(self, message, -1) );
					messages.add( message );
				}
			}
			else if (args.length == 2) 			{
				Token token_2_0 = new Token();
				// bind(args[0], args[1])
				{
					Message message = new Message( self, self, "bind", token_2_0.createInput() );
					Object _arguments[] = { args[0], args[1] };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// whereAmI(args[0])
				{
					Message message = new Message( self, self, "whereAmI", null );
					Object _arguments[] = { args[0] };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_0.createOutput(self, message, -1) );
					messages.add( message );
				}
			}
		}
	}
}