// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

import java.io.*;
public class Heat extends ActorReference  {
	public Heat selfReference;

	public Heat(UAN uan) { super(uan); }
	public Heat(UAL ual) { super(ual); }

	public static void main(String args[]) {
		Heat instance = new Heat();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public Heat() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected Heat self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		int iterations = 1024;
		int x = 126;
		int y = 126;
		int actors = 4;
		String nameServer = "jupiter.wcl.cs.rpi.edu";
		String theatersFile = "wcl.txt";
		String fileName = "heat-salsa.map";
		public double[][] createInitialData() {
			double[][] data = new double[x][];
			for (int i = 0; i < x; i++){
				data[i] = new double[y];
				for (int j = 0; j < y; j++){
					data[i][j] = 20.0;
					if (i == 0 || j == 0 || i == x - 1 || j == y - 1) data[i][j] = 20.0;
					if (j == 0 && i > x / 4 && i < 3 * x / 4) data[i][j] = 100.0;
				}
			}
			return data;
		}
		public double[][] doWork(double[][] data, int iterations, int noActors, String nameServer, String theatersFile) {
			double[][] next = new double[x][];
			for (int i = 0; i < x; i++){
				next[i] = new double[y];
				System.arraycopy(data[i], 0, next[i], 0, y);
			}
			long initialTime = System.currentTimeMillis();
			for (int k = 0; k < iterations; k++){
				for (int i = 1; i < x - 1; i++)for (int j = 1; j < y - 1; j++)next[i][j] = 0.25 * (data[i - 1][j] + data[i][j - 1] + data[i + 1][j] + data[i][j + 1]);
				double[][] temp = next;
				next = data;
				data = temp;
			}
			long finalTime = System.currentTimeMillis();
			long runningTime = finalTime - initialTime;
			double processingRate = 1.0 * iterations * (x - 2) * (y - 2) / runningTime;
			{
				// standardOutput<-println("Time for " + iterations + " iterations on " + (x - 2) + "," + (y - 2) + " grid: " + runningTime + " ms.")
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { "Time for " + iterations + " iterations on " + (x - 2) + "," + (y - 2) + " grid: " + runningTime + " ms." };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			{
				// standardOutput<-println("Execution rate: " + processingRate + " points/ms")
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { "Execution rate: " + processingRate + " points/ms" };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			return data;
		}
		public void produceFile(double[][] data, String fileName) {
			try {
				PrintWriter out = new PrintWriter(new FileWriter(fileName));
				out.println(x + " " + y);
				for (int i = 0; i < x; i++){
					for (int j = 0; j < y; j++)out.println(data[i][j]);
				}
				out.flush();
				out.close();
			}
			catch (IOException ioe) {
				{
					// standardOutput<-println("[error] Can't open the file " + fileName + " for writing.")
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { "[error] Can't open the file " + fileName + " for writing." };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}

		}
		public void act(String args[]) {
			int argc = args.length;
			if (argc >= 1) iterations = Integer.parseInt(args[0]);
			if (argc >= 2) x = Integer.parseInt(args[1]);
			if (argc >= 3) y = Integer.parseInt(args[2]);
			if (argc >= 4) actors = Integer.parseInt(args[3]);
			if (argc >= 5) nameServer = args[4];
			if (argc >= 6) theatersFile = args[5];
			if (argc >= 7) fileName = args[6];
			x += 2;
			y += 2;
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				// createInitialData()
				{
					Message message = new Message( self, self, "createInitialData", token_2_0.createInput() );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// doWork(token, new Integer(iterations), new Integer(actors), nameServer, theatersFile)
				{
					Message message = new Message( self, self, "doWork", token_2_1.createInput() );
					Object _arguments[] = { token_2_0.createOutput(self, message, 0), new Integer(iterations), new Integer(actors), nameServer, theatersFile };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// produceFile(token, fileName)
				{
					Message message = new Message( self, self, "produceFile", null );
					Object _arguments[] = { token_2_1.createOutput(self, message, 0), fileName };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
	}
}