package examples.messenger;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

public class Letter extends ActorReference  {
	public Letter selfReference;

	public Letter(UAN uan) { super(uan); }
	public Letter(UAL ual) { super(ual); }

	public static void main(String args[]) {
		Letter instance = new Letter();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public Letter(Sender _sender, String _name) {
		selfReference = this;
		State state = new State(_sender, _name);
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public Letter() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected Letter self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		Sender sender;
		String name;
		State(Sender _sender, String _name) {
			self.ual = __ual;
			Vector messages = new Vector();

			sender = _sender;
			name = _name;
			ServiceFactory.getTransport().send(messages);
		}
		public String toString() {
			return name;
		}
		public void retry(Recipient recipient) {
			if (recipient != null) 			{
				Token token_2_0 = new Token();
				// recipient<-process(self)
				{
					Message message = new Message( self, recipient, "process", token_2_0.createInput() );
					Object _arguments[] = { self };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// self<-retry(token)
				{
					Message message = new Message( self, self, "retry", null );
					Object _arguments[] = { token_2_0.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public void failed(Recipient recipient) {
			if (recipient != null) {
				try {
					Thread.currentThread().sleep(1000);
				}
				catch (InterruptedException ie) {
				}

				{
					Token token_3_0 = new Token();
					// recipient<-process(self)
					{
						Message message = new Message( self, recipient, "process", token_3_0.createInput() );
						Object _arguments[] = { self };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
					// self<-failedTwice(token)
					{
						Message message = new Message( self, self, "failedTwice", null );
						Object _arguments[] = { token_3_0.createOutput(self, message, 0) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 1 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}
		}
		public void failedTwice(Recipient recipient) {
			if (recipient != null) 			{
				// sender<-log(self)
				{
					Message message = new Message( self, sender, "log", null );
					Object _arguments[] = { self };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
	}
}