package examples.migration;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

public class LargeAgent extends Agent {
	public LargeAgent selfReference;

	public LargeAgent(UAN uan) { super(uan); }
	public LargeAgent(UAL ual) { super(ual); }

	public static void main(String args[]) {
		LargeAgent instance = new LargeAgent();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public LargeAgent() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Agent.State {
		protected LargeAgent self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		byte[] largeData;
		public void setSize(int size) {
			largeData = new byte[size];
		}
		public void act(String[] args) {
			try {
				{
					Token token_3_0 = new Token();
					Token token_3_1 = new Token();
					Token token_3_2 = new Token();
					Token token_3_3 = new Token();
					// setSize(new Integer(args[0]))
					{
						Message message = new Message( self, self, "setSize", token_3_0.createInput() );
						Object _arguments[] = { new Integer(args[0]) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
					// addLocation(args[2])
					{
						Message message = new Message( self, self, "addLocation", token_3_1.createInput() );
						Object _arguments[] = { args[2] };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( token_3_0.createOutput(self, message, -1) );
						messages.add( message );
					}
					// bind(args[1], args[2])
					{
						Message message = new Message( self, self, "bind", token_3_2.createInput() );
						Object _arguments[] = { args[1], args[2] };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( token_3_1.createOutput(self, message, -1) );
						messages.add( message );
					}
					// startTime()
					{
						Message message = new Message( self, self, "startTime", token_3_3.createInput() );
						Object _arguments[] = {  };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( token_3_2.createOutput(self, message, -1) );
						messages.add( message );
					}
					// go(args, "3")
					{
						Message message = new Message( self, self, "go", null );
						Object _arguments[] = { args, "3" };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( token_3_3.createOutput(self, message, -1) );
						messages.add( message );
					}
				}
			}
			catch (Exception e) {
				{
					// standardOutput<-println(e)
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { e };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
				{
					// standardOutput<-println("Usage: java migration.LargeAgent size UAN UAL (<UAL>)*")
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { "Usage: java migration.LargeAgent size UAN UAL (<UAL>)*" };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}

		}
	}
}