package examples.ping;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

public class Ping extends ActorReference  {
	public Ping selfReference;

	public Ping(UAN uan) { super(uan); }
	public Ping(UAL ual) { super(ual); }

	public static void main(String args[]) {
		Ping instance = new Ping();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public Ping() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected Ping self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		long startTime;
		public void ping(String localUAL, String remoteUAL) {
			{
				// standardOutput<-println("Sending PING to actor at " + remoteUAL)
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { "Sending PING to actor at " + remoteUAL };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			EchoAgent a = new EchoAgent();
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				Token token_2_2 = new Token();
				// a<-getReferenceByLocation(remoteUAL)
				{
					Message message = new Message( self, a, "getReferenceByLocation", token_2_0.createInput() );
					Object _arguments[] = { remoteUAL };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// a<-registerUAL(localUAL)
				{
					Message message = new Message( self, a, "registerUAL", token_2_1.createInput() );
					Object _arguments[] = { localUAL };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_0.createOutput(a, message, -1) );
					messages.add( message );
				}
				// startTime()
				{
					Message message = new Message( self, self, "startTime", token_2_2.createInput() );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_1.createOutput(self, message, -1) );
					messages.add( message );
				}
				// a<-echo()
				{
					Message message = new Message( self, a, "echo", null );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_2.createOutput(a, message, -1) );
					messages.add( message );
				}
			}
		}
		public void startTime() {
			startTime = System.currentTimeMillis();
		}
		public void pong() {
			long roundTrip = System.currentTimeMillis() - startTime;
			{
				Token token_2_0 = new Token();
				// standardOutput<-println("Received ECHO within " + String.valueOf(roundTrip) + " ms.")
				{
					Message message = new Message( self, standardOutput, "println", token_2_0.createInput() );
					Object _arguments[] = { "Received ECHO within " + String.valueOf(roundTrip) + " ms." };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// standardOutput<-println("Message sending avg time: " + String.valueOf(roundTrip / 2) + " ms.")
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { "Message sending avg time: " + String.valueOf(roundTrip / 2) + " ms." };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_0.createOutput(standardOutput, message, -1) );
					messages.add( message );
				}
			}
		}
		public void act(String args[]) {
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				// bind(args[0], args[1])
				{
					Message message = new Message( self, self, "bind", token_2_0.createInput() );
					Object _arguments[] = { args[0], args[1] };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// migrate(args[1])
				{
					Message message = new Message( self, self, "migrate", token_2_1.createInput() );
					Object _arguments[] = { args[1] };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_0.createOutput(self, message, -1) );
					messages.add( message );
				}
				// ping(args[1], args[2])
				{
					Message message = new Message( self, self, "ping", null );
					Object _arguments[] = { args[1], args[2] };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_1.createOutput(self, message, -1) );
					messages.add( message );
				}
			}
		}
	}
}